Declare DriverEntry(*DriverObject, *RegistryPath)

ImportC "ntoskrnl.lib"
	DbgPrint(*String)
	memset(*mem, Byte, Size)
EndImport

Import "ntoskrnl.lib"
  ZwQuerySystemInformation(SysInfoClass, *SysInfo, SysInfoLength.l, *ReturnLength)
  ExAllocatePool(PoolType, NumBytes)
  ExFreePool(*Point)
EndImport

!extrn _memset

 *A=@DriverEntry()
!jmp [p_A]

XIncludeFile "StringDr.pbi"

EnableExplicit

Structure DrArray_SMI
  Arrays.SYSTEM_MODULE_INFORMATION[1]
EndStructure

;   .     .
Procedure DriverEntry(*DriverObject.DRIVER_OBJECT, *RegistryPath.UNICODE_STRING)
  Protected cb.l, *p, *pArray.DrArray_SMI
  Protected dwNumModules.l
  Protected Buffer.s{128}, Temp
  
  DbgPrint(@"LoadDriver")
  
  cb=0
  ZwQuerySystemInformation(#SystemModuleInformation, @*p, 0, @cb)
  If cb <> 0 ;
    cb + 32
    *p = ExAllocatePool(#PagedPool, cb)
    If *p<>#Null
      If ZwQuerySystemInformation(#SystemModuleInformation, *p, cb, @cb)= #STATUS_SUCCESS

        
        PokeS(@Buffer, "Bytes:  ") : Temp=8
        Temp+StrDr(@Buffer+Temp, 128-Temp, cb)
        PokeS(@Buffer+Temp, ";  Address: 0x") : Temp+14
        Temp+HexDr(@Buffer+Temp, 128-Temp, *p)
        PokeS(@Buffer+Temp, ";  Modules: ") : Temp+12
        Temp+StrDr(@Buffer+Temp, 128-Temp, dwNumModules)
        
        DbgPrint(@Buffer)
        memset(@Buffer, 0, 128)
        
        
        *pArray = *p
        dwNumModules = PeekL(*pArray)
        *pArray + 4
        
        Temp=0
        While Temp < dwNumModules

          DbgPrint(@*pArray\Arrays[Temp]\ImageName[0])
          
          Temp+1
        Wend
          
      EndIf
      
      ExFreePool(*p)
    EndIf
  EndIf
  
  ;       .
	ProcedureReturn #STATUS_DEVICE_CONFIGURATION_ERROR  ;#STATUS_SUCCESS
EndProcedure

; IDE Options = PureBasic 5.10 Beta 8 (Windows - x86)
; CursorPosition = 14
; FirstLine = 1
; Folding = -
; EnableAsm
; Executable = DrMem.sys
; DisableDebugger
; EnableBuildCount = 77
; EnableExeConstant